"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
// @ts-nocheck
require("./element-highlight.css");
const react_1 = __importStar(require("react"));
const useCapture = true;
const activeClassName = "contenteditable-element-selector-active";
const ElementHighlight = ({ applicationRootElement, isActiveRef, onSelect, children, }) => {
    (0, react_1.useEffect)(() => {
        const mouseOutCallback = (event) => {
            const target = event.target;
            if (!applicationRootElement.contains(target))
                return;
            target.classList.remove("contenteditable-element-hover");
        };
        const mouseOverCallback = (event) => {
            const target = event.target;
            if (!isActiveRef || !isActiveRef.current)
                return;
            if (!applicationRootElement.contains(target))
                return;
            target.classList.add("contenteditable-element-hover");
        };
        const mouseClickCallback = (event) => {
            const target = event.target;
            if (!isActiveRef || !isActiveRef.current)
                return;
            if (!applicationRootElement.contains(target))
                return;
            event.preventDefault();
            event.stopPropagation();
            const selected = document.querySelector(".contenteditable-element-seleted");
            if (selected)
                selected.classList.remove("contenteditable-element-seleted");
            target.classList.add("contenteditable-element-seleted");
            onSelect(target);
        };
        window.addEventListener("mouseout", mouseOutCallback, useCapture);
        window.addEventListener("mouseover", mouseOverCallback, useCapture);
        window.addEventListener("click", mouseClickCallback, useCapture);
        return () => {
            window.removeEventListener("mouseout", mouseOutCallback, useCapture);
            window.removeEventListener("mouseover", mouseOverCallback, useCapture);
            window.removeEventListener("click", mouseClickCallback, useCapture);
        };
    }, []);
    (0, react_1.useEffect)(() => {
        if (isActiveRef && isActiveRef.current) {
            const propKey = isActiveRef.current ? "add" : "remove";
            window.document.body.classList[propKey](activeClassName);
        }
        return () => {
            window.document.body.classList.remove(activeClassName);
        };
    }, [isActiveRef && isActiveRef.current]);
    return children ? react_1.default.createElement(react_1.default.Fragment, null, children) : null;
};
exports.default = ElementHighlight;
